1 2 3 4 5 6 7 8 9 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31 32 33 34 35 36 37 38 39 40 41 42 43 44 45 46 47 48 49 50 51 52 53 54 55 56 57 58 59 60 61 62 63 64 65 66 67 68 69 70 71 72 73 74 75 76 77 78 79 80 81 82 83 84 85 86 87 88 89 90 91 92 93 94 95 96 97 98 99 100 101 102 103 104 105 106 107 108 109 110 111 112 113 114 115 116 117 118 119 120 121 122 123 124 125 126 127 128 129 130 131 132 133 134 135 136 137 138 139 140 141 142 143 144 145 146 147 148 149 150 151 152 153 154 155 156 157 158 159 160 161 162 163 164 165 166 167 168 169 170 171 172 173 174 175 176 177 178 179 180 181 182 183 184 185 186 187 188 189 190 191 192 193 194 195 196 197 198 199 200 201 202 203 204 205 206 207 208 209 210 211 212 213 214 215 216 217 218 219 220 221 222 223 224 225 226 227 228 229 230 231 232 233 234 235 236 237 238 239 240 241 242 243 244 245 246 247 248 249 250 251 252 253 254 255 256 257 258 259 260 261 262 263 264 265 266 267 268 269 270 271 272 273 274 275 276 277 278 279 280 281 282 283 284 285 286 287 288 289 290 291 292 293 294 295 296 297 298 299 300 301 302 303 304 305 306 307 308 309 310 311 312 313 314 315 316 317 318 319 320 321 322 323 324 325 326 327 328 329 330 331 332 333 334 335 336 337 338 339 340 341 342 343 344 345 346 347 348 349 350 351 352 353 354 355 356 357 358 359 360 361 362 363 364 365 366 367 368 369 370 371 372 373 374 375 376 377 378 379 380 381 382 383 384 385 386 387 388 389 390 391 392 393 394 395 396 397 398 399 400 401 402 403 404 405 406 407 408 409 410 411 412 413 414 415 416 417 418 419 420 421 422 423 424 425 426 427 428 429 430 431 432 433 434 435 436 437 438 439 440 441 442 443 444 445 446 447 448 449 450 451 452 453 454 455 456 457 458 459 460 461 462 463 464 465 466 467 468 469 470 471 472 473 474 475 476 477 478 479 480 481 482 483 484 485 486 487 488 489 490 491 492 493 494 495 496 497 498 499 500 501 502 503 504 505 506 507 508 509 510 511 512 513 514 515 516 517 518 519 520 521 522 523 524 525 526 527 528 529 530 531 532 533 534 535 536 537 538 539 540 541 542 543 544 545 546 547 548 549 550 551 552 553 554 555 556 557 558 559 560 561 562 563 564 565 566 567 568 569 570 571 572 573 574 575 576 577 578 579 580 581 582 583 584 585 586 587 588 589 590 591 592 593 594 595 596 597 598 599 600 601 602 603 604 605 606 607 608 609 610 611 612 613 614 615 616 617 618 619 620 621 622 623 624 625 626 627 628 629 630 631 632 633 634 635 636 637 638 639 640 641 642 643 644 645 646 647 648 649 650 651 652 653 654 655 656 657 658 659 660 661 662 663 664 665 666 667 668 669 670 671 672 673 674 675 676 677 678 679 680 681 682 683 684 685 686 687 688 689 690 691 692 693 694 695 696 697 698 699 700 701 702 703 704 705 706 707 708 709 710 711 712 713 714 715 716 717 718 719 720 721 722 723 724 725 726 727 728 729 730 731 732 733 734 735 736 737 738 739 740 741 742 743 744 745 746 747 748 749 750 751 752 753 754 755 756 757 758 759 760 761 762 763 764 765 766 767 768 769 770 771 772 773 774 775 776 777 778 779 780 781 782 783 784 785 786 787 788 789 790 791 792 793 794 795 796 797 798 799 800 801 802 803 804 805 806 807 808 809 810 811 812 813 814 815 816 817 818 819 820 821 822 823 824 825 826 827 828 829 830 831 832 833 834 835 836 837 838 839 840 841 842 843 844 845 846 847 848 849 850 851 852 853 854 855 856 857 858 859 860 861 862 863 864 865 866 867 868 869 870 871 872 873 874 875 876 877 878 879 880 881 882 883 884 885 886 887 888 889 890 891 892 893 894 895 896 897 898 899 900 901 902 903 904 905 906 907 908 909 910 911 912 913 914 915 916 917 918 919 920 921 922 923 924 925 926 927 928 929 930 931 932 933 934 935 936 937 938 939 940 941 942 943 944 945 946 947 948 949 950 951 952 953 954 955 956 957 958 959 960 961 962 963 964 965 966 967 968 969 970 971 972 973 974 975 976 977 978 979 980 981 982 983 984 985 986 987 988 989 990 991 992 993 994 995 996 997 998 999 1000 1001 1002 1003 1004 1005 1006 1007 1008 1009 1010 1011 1012 1013 1014 1015 1016 1017 1018 1019 1020 1021 1022 1023 1024 1025 1026 1027 1028 1029 1030 1031 1032 1033 1034 1035 1036 1037 1038 1039 1040 1041 1042 1043 1044 1045 1046 1047 1048 1049 1050 1051 1052 1053 1054 1055 1056 1057 1058 1059 1060 1061 1062 1063 1064 1065 1066 1067 1068 1069 1070 1071 1072 1073 1074 1075 1076 1077 1078 1079 1080 1081 1082 1083 1084 1085 1086 1087 1088 1089 1090 1091 1092 1093 1094 1095 1096 1097 1098 1099 1100 1101 1102 1103 1104 1105 1106 1107 1108 1109 1110 1111 1112 1113 1114 1115 1116 1117 1118 1119 1120 1121 1122 1123 1124 1125 1126 1127 1128 1129 1130 1131 1132 1133 1134 1135 1136 1137 1138 1139 1140 1141 1142 1143 1144 1145 1146 1147 1148 1149 1150 1151 1152 1153 1154 1155 1156 1157 1158 1159 1160 1161 1162 1163 1164 1165 1166 1167 1168 1169 1170 1171 1172 1173 1174 1175 1176 1177 1178 1179 1180 1181 1182 1183 1184 1185 1186 1187 1188 1189 1190 1191 1192 1193 1194 1195 1196 1197 1198 1199 1200 1201 1202 1203 1204 1205 1206 1207 1208 1209 1210 1211 1212 1213 1214 1215 1216 1217 1218 1219 1220 1221 1222 1223 1224 1225 1226 1227 1228 1229 1230 1231 1232 1233 1234 1235 1236 1237 1238 1239 1240 1241 1242 1243 1244 1245 1246 1247 1248 1249 1250 1251 1252 1253 1254 1255 1256 1257 1258 1259 1260 1261 1262 1263 1264 1265 1266 1267 1268 1269 1270 1271 1272 1273 1274 1275 1276 1277 1278 1279 1280 1281 1282 1283 1284 1285 1286 1287 1288 1289 1290 1291 1292 1293 1294 1295 1296 1297 1298 1299 1300 1301 1302 1303 1304 1305 1306 1307 1308 1309 1310 1311 1312 1313 1314 1315 1316 1317 1318 1319 1320 1321 1322 1323 1324 1325 1326 1327 1328 1329 1330 1331 1332 1333 1334 1335 1336 1337 1338 1339 1340 1341 1342 1343 1344 1345 1346 1347 1348 1349 1350 1351 1352 1353 1354 1355 1356 1357 1358 1359 1360 1361 1362 1363 1364 1365 1366 1367 1368 1369 1370 1371 1372 1373 1374 1375 1376 1377 1378 1379 1380 1381 1382 1383 1384 1385 1386 1387 1388 1389 1390 1391 1392 1393 1394 1395 1396 1397 1398 1399 1400 1401 1402 1403 1404 1405 1406 1407 1408 1409 1410 1411 1412 1413 1414 1415 1416 1417 1418 1419 1420 1421 1422 1423 1424 1425 1426 1427 1428 1429 1430 1431 1432 1433 1434 1435 1436 1437 1438 1439 1440 1441 1442 1443 1444 1445 1446 1447 1448 1449 1450 1451 1452 1453 1454 1455 1456 1457 1458 1459 1460 1461 1462 1463 1464 1465 1466 1467 1468 1469 1470 1471 1472 1473 1474 1475 1476 1477 1478 1479 1480 1481 1482 1483 1484 1485 1486 1487 1488 1489 1490 1491 1492 1493 1494 1495 1496 1497 1498 1499 1500 1501 1502 1503 1504 1505 1506 1507 1508 1509 1510 1511 1512 1513 1514 1515 1516 1517 1518 1519 1520 1521 1522 1523 1524 1525 1526 1527 1528 1529 1530 1531 1532 1533 1534 1535 1536 1537 1538 1539 1540 1541 1542 1543 1544 1545 1546 1547 1548 1549 1550 1551 1552 1553 1554 1555 1556 1557 1558 1559 1560 1561 1562 1563 1564 1565 1566 1567 1568 1569 1570 1571 1572 1573 1574 1575 1576 1577 1578 1579 1580 1581 1582 1583 1584 1585 1586 1587 1588 1589 1590 1591 1592 1593 1594 1595 1596 1597 1598 1599 1600 1601 1602 1603 1604 1605 1606 1607 1608 1609 1610 1611 1612 1613 1614 1615 1616 1617 1618 1619 1620 1621 1622 1623 1624 1625 1626 1627 1628 1629 1630 1631 1632 1633 1634 1635 1636 1637 1638 1639 1640 1641 1642 1643 1644 1645 1646 1647 1648 1649 1650 1651 1652 1653 1654 1655 1656 1657 1658 1659 1660 1661 1662 1663 1664 1665 1666 1667 1668 1669 1670 1671 1672 1673 1674 1675 1676 1677 1678 1679 1680 1681 1682 1683 1684 1685 1686 1687 1688 1689 1690 1691 1692 1693 1694 1695 1696 1697 1698 1699 1700 1701 1702 1703 1704 1705 1706 1707 1708 1709 1710 1711 1712 1713 1714 1715 1716 1717 1718 1719 1720 1721 1722 1723 1724 1725 1726 1727 1728 1729 1730 1731 1732 1733 1734 1735 1736 1737 1738 1739 1740 1741 1742 1743 1744 1745 1746 1747 1748 1749 1750 1751 1752 1753 1754 1755 1756 1757 1758 1759 1760 1761 1762 1763 1764 1765 1766 1767 1768 1769 1770 1771 1772 1773 1774 1775 1776 1777 1778 1779 1780 1781 1782 1783 1784 1785 1786 1787 1788 1789 1790 1791 1792 1793 1794 1795 1796 1797 1798 1799 1800 1801 1802 1803 1804 1805 1806 1807 1808 1809 1810 1811 1812 1813 1814 1815 1816 1817 1818 1819 1820 1821 1822 1823 1824 1825 1826 1827 1828 1829 1830 1831 1832 1833 1834 1835 1836 1837 1838 1839 1840 1841 1842 1843 1844 1845 1846 1847 1848 1849 1850 1851 1852 1853 1854 1855 1856 1857 1858 1859 1860 1861 1862 1863 1864 1865 1866 1867 1868 1869 1870 1871 1872 1873 1874 1875 1876 1877 1878 1879 1880 1881 1882 1883 1884 1885 1886 1887 1888 1889 1890 1891 1892 1893 1894 1895 1896 1897 1898 1899 1900 1901 1902 1903 1904 1905 1906 1907 1908 1909 1910 1911 1912 1913 1914 1915 1916 1917 1918 1919 1920 1921 1922 1923 1924 1925 1926 1927 1928 1929 1930 1931 1932 1933 1934 1935 1936 1937 1938 1939 1940 1941 1942 1943 1944 1945 1946 1947 1948 1949 1950 1951 1952 1953 1954 1955 1956 1957 1958 1959 1960 1961 1962 1963 1964 1965 1966 1967 1968 1969 1970 1971 1972 1973 1974 1975 1976 1977 1978 1979 1980 1981 1982 1983 1984 1985 1986 1987 1988 1989 1990 1991 1992 1993 1994 1995 1996 1997 1998 1999 2000 2001 2002 2003 2004 2005 2006 2007 2008 2009 2010 2011 2012 2013 2014 2015 2016 2017 2018 2019 2020 2021 2022 2023 2024 2025 2026 2027 2028 2029 2030 2031 2032 2033 2034 2035 2036 2037 2038 2039 2040 2041 2042 2043 2044 2045 2046 2047 2048 2049 2050 2051 2052 2053 2054 2055 2056 2057 2058 2059 2060 2061 2062 2063 2064 2065 2066 2067 2068 2069 2070 2071 2072 2073 2074 2075 2076 2077 2078 2079 2080 2081 2082 2083 2084 2085 2086 2087 2088 2089 2090 2091 2092 2093 2094 2095 2096 2097 2098 2099 2100 2101 2102 2103 2104 2105 2106 2107 2108 2109 2110 2111 2112 2113 2114 2115 2116 2117 2118 2119 2120 2121 2122 2123 2124 2125 2126 2127 2128 2129 2130 2131 2132 2133 2134 2135 2136 2137 2138 2139 2140 2141 2142 2143 2144 2145 2146 2147 2148 2149 2150 2151 2152 2153 2154 2155 2156 2157 2158 2159 2160 2161 2162 2163 2164 2165 2166 2167 2168 2169 2170 2171 2172 2173 2174 2175 2176 2177 2178 2179 2180 2181 2182 2183 2184 2185 2186 2187 2188 2189 2190 2191 2192 2193 2194 2195 2196 2197 2198 2199 2200 2201 2202 2203 2204 2205 2206 2207 2208 2209 2210 2211 2212 2213 2214 2215 2216 2217 2218 2219 2220 2221 2222 2223 2224 2225 2226 2227 2228 2229 2230 2231 2232 2233 2234 2235 2236 2237 2238 2239 2240 2241 2242 2243 2244 2245 2246 2247 2248 2249 2250 2251 2252 2253 2254 2255 2256 2257 2258 2259 2260 2261 2262 2263 2264 2265 2266 2267 2268 2269 2270 2271 2272 2273 2274 2275 2276 2277 2278 2279 2280 2281 2282 2283 2284 2285 2286 2287 2288 2289 2290 2291 2292 2293 2294 2295 2296 2297 2298 2299 2300 2301 2302 2303 2304 2305 2306 2307 2308 2309 2310 2311
|
# variables in header
Openstack-Auth-Receipt:
description: |
The auth receipt. A partially successful authentication
response returns the auth receipt ID in this header rather than in the
response body.
in: header
required: true
type: string
X-Auth-Token:
description: |
A valid authentication token for an
administrative user.
in: header
required: true
type: string
X-Subject-Token:
description: |
The authentication token. An authentication
response returns the token ID in this header rather than in the
response body.
in: header
required: true
type: string
# variables in path
credential_id_path:
description: |
The UUID for the credential.
in: path
required: true
type: string
domain_id_path:
description: |
The domain ID.
in: path
required: true
type: string
endpoint_id_path:
description: |
The endpoint ID.
in: path
required: true
type: string
group_id:
description: |
The group ID.
in: path
required: true
type: string
group_id_path:
description: |
The group ID.
in: path
required: true
type: string
implies_role_id:
description: |
Role ID for an implied role.
in: path
required: true
type: string
limit_id_path:
description: |
The limit ID.
in: path
required: true
type: string
option:
description: |
The option name. For the ``ldap`` group, a valid
value is ``url`` or ``user_tree_dn``. For the ``identity`` group,
a valid value is ``driver``.
in: path
required: true
type: string
policy_id_path:
description: |
The policy ID.
in: path
required: true
type: string
prior_role_id:
description: |
Role ID for a prior role.
in: path
required: true
type: string
project_id_path:
description: |
The project ID.
in: path
required: true
type: string
project_tag_path:
description: |
A simple string associated with a project. Can be used for assigning
values to projects and filtering based on those values.
in: path
required: true
type: string
region_id_path:
description: |
The region ID.
in: path
required: true
type: string
registered_limit_id_path:
description: |
The registered limit ID.
in: path
required: true
type: string
request_access_rule_id_path_required:
description: |
The ID of the access rule.
in: path
required: true
type: string
request_access_rule_user_id_path_required:
description: |
The ID of the user who owns the access rule.
in: path
required: true
type: string
request_application_credential_id_path_required:
description: |
The ID of the application credential.
in: path
required: true
type: string
request_application_credential_user_id_path_required:
description: |
The ID of the user who owns the application credential.
in: path
required: true
type: string
role_id:
description: |
The role ID.
in: path
required: true
type: string
role_id_path:
description: |
The role ID.
in: path
required: true
type: string
service_id_path:
description: |
The service ID.
in: path
required: true
type: string
user_id_path:
description: |
The user ID.
in: path
required: true
type: string
# variables in query
allow_expired:
description: |
(Since v3.8) Allow fetching a token that has expired. By default expired
tokens return a 404 exception.
in: query
required: false
type: bool
domain_enabled_query:
description: |
If set to true, then only domains that are enabled will be returned, if set
to false only that are disabled will be returned. Any value other than
``0``, including no value, will be interpreted as true.
in: query
required: false
type: string
domain_id_query:
description: |
Filters the response by a domain ID.
in: query
required: false
type: string
domain_name_query:
description: |
Filters the response by a domain name.
in: query
required: false
type: string
effective_query:
description: |
Returns the effective assignments, including any assignments gained by
virtue of group membership.
in: query
required: false
type: key-only (no value required)
enabled_user_query:
description: |
Filters the response by either enabled (``true``)
or disabled (``false``) users.
in: query
required: false
type: string
group_id_query:
description: |
Filters the response by a group ID.
in: query
required: false
type: string
group_name_query:
description: |
Filters the response by a group name.
in: query
required: false
type: string
idp_id_query:
description: |
Filters the response by an identity provider ID.
in: query
required: false
type: string
include_limits:
description: |
It should be used together with `parents_as_list` or `subtree_as_list`
filter to add the related project's limits into the response body.
in: query
required: false
type: key-only, no value expected
include_names_query:
description: |
If set to true, then the names of any entities returned will be include as
well as their IDs. Any value other than ``0`` (including no value) will be
interpreted as true.
in: query
required: false
type: boolean
min_version: 3.6
include_subtree_query:
description: |
If set to true, then relevant assignments in the project hierarchy below
the project specified in the ``scope.project_id`` query parameter are also
included in the response. Any value other than ``0`` (including no value)
for ``include_subtree`` will be interpreted as true.
in: query
required: false
type: boolean
min_version: 3.6
interface_query:
description: |
Filters the response by an interface.
in: query
required: false
type: string
is_domain_query:
description: |
If this is specified as true, then only projects acting as a domain are
included. Otherwise, only projects that are not acting as a domain are
included.
in: query
required: false
type: boolean
min_version: 3.6
limit_query:
description: |
Requests a page size of items. Returns a number of items up to a limit
value. Use the limit parameter to make an initial limited request and use
the ID of the last-seen item from the response as the marker parameter
value in a subsequent limited request.
in: query
required: false
type: integer
marker_query:
description: |
The ID of the last-seen item. Use the limit parameter to make an
initial limited request and use the ID of the last-seen item from the
response as the marker parameter value in a subsequent limited request
in: query
required: false
type: string
name_user_query:
description: |
Filters the response by a user name.
in: query
required: false
type: string
nocatalog:
description: |
(Since v3.1) The authentication response excludes
the service catalog. By default, the response includes the service
catalog.
in: query
required: false
type: string
parent_id_query:
description: |
Filters the response by a parent ID.
in: query
required: false
type: string
min_version: 3.4
parent_region_id_query_not_required:
description: |
Filters the response by a parent region, by ID.
in: query
required: false
type: string
parents_as_ids:
description: |
The entire parent hierarchy will be included as
nested dictionaries in the response. It will contain
all projects ids found by traversing up the hierarchy
to the top-level project.
in: query
required: false
type: key-only, no value expected
min_version: 3.4
parents_as_list:
description: |
The parent hierarchy will be included as a list in the response.
This list will contain the projects found by traversing up the
hierarchy to the top-level project. The returned list will be
filtered against the projects the user has an effective role
assignment on.
in: query
required: false
type: key-only, no value expected
min_version: 3.4
password_expires_at_query:
description: |
Filter results based on which user passwords have expired. The query should
include an ``operator`` and a ``timestamp`` with a colon (``:``) separating
the two, for example::
password_expires_at={operator}:{timestamp}
- Valid operators are: ``lt``, ``lte``, ``gt``, ``gte``, ``eq``, and ``neq``
- lt: expiration time lower than the timestamp
- lte: expiration time lower than or equal to the timestamp
- gt: expiration time higher than the timestamp
- gte: expiration time higher than or equal to the timestamp
- eq: expiration time equal to the timestamp
- neq: expiration time not equal to the timestamp
- Valid timestamps are of the form: ``YYYY-MM-DDTHH:mm:ssZ``.
For example::
/v3/users?password_expires_at=lt:2016-12-08T22:02:00Z
The example would return a list of users whose password expired before the
timestamp (``2016-12-08T22:02:00Z``).
in: query
required: false
type: string
policy_type_query:
description: |
Filters the response by a MIME media type for the
serialized policy blob. For example, ``application/json``.
in: query
required: false
type: string
project_enabled_query:
description: |
If set to true, then only enabled projects will be returned. Any value
other than ``0`` (including no value) will be interpreted as true.
in: query
required: false
type: boolean
project_name_query:
description: |
Filters the response by a project name.
in: query
required: false
type: string
protocol_id_query:
description: |
Filters the response by a protocol ID.
in: query
required: false
type: string
region_id_query:
description: |
Filters the response by a region ID.
in: query
required: false
type: string
request_application_credential_name_query_not_required:
description: |
The name of the application credential. Must be unique to a user.
in: query
required: false
type: string
request_nocatalog_unscoped_path_not_required:
description: |
(Since v3.1) nocatalog only works for scoped token. For unscoped token, the
authentication response always excludes the service catalog.
in: query
required: false
type: string
request_service_name_query_not_required:
description: |
Filters the response by a service name.
in: query
required: false
type: string
resource_name_query:
description: |
Filters the response by a specified resource name.
in: query
required: false
type: string
role_id_query:
description: |
Filters the response by a role ID.
in: query
required: false
type: string
role_name_query:
description: |
Filters the response by a role name.
in: query
required: false
type: string
scope_domain_id_query:
description: |
Filters the response by a domain ID.
in: query
required: false
type: string
scope_os_inherit_inherited_to:
description: |
Filters based on role assignments that are inherited.
The only value of ``inherited_to`` that is currently
supported is ``projects``.
in: query
required: false
type: string
scope_project_id_query:
description: |
Filters the response by a project ID.
in: query
required: false
type: string
scope_system_query:
description: |
Filters the response by system assignments.
in: query
required: false
type: string
service_id_query:
description: |
Filters the response by a service ID.
in: query
required: false
type: string
service_type_query:
description: |
Filters the response by a service type. A valid
value is ``compute``, ``ec2``, ``identity``, ``image``,
``network``, or ``volume``.
in: query
required: false
type: string
sort_dir:
description: |
Sort direction. A valid value is asc (ascending) or desc
(descending).
in: query
required: false
type: string
sort_key:
description: |
Sorts resources by attribute
in: query
required: false
type: string
subtree_as_ids:
description: |
The entire child hierarchy will be included as nested dictionaries
in the response. It will contain all the projects ids found by
traversing down the hierarchy.
in: query
required: false
type: key-only, no value expected
min_version: 3.4
subtree_as_list:
description: |
The child hierarchy will be included as a list in the response.
This list will contain the projects found by traversing down
the hierarchy. The returned list will be filtered against the
projects the user has an effective role assignment on.
in: query
required: false
type: key-only, no value expected
min_version: 3.4
unique_id_query:
description: |
Filters the response by a unique ID.
in: query
required: false
type: string
user_id_query:
description: |
Filters the response by a user ID.
in: query
required: false
type: string
# variables in body
audit_ids:
description: |
A list of one or two audit IDs. An audit ID is a
unique, randomly generated, URL-safe string that you can use to
track a token. The first audit ID is the current audit ID for the
token. The second audit ID is present for only re-scoped tokens
and is the audit ID from the token before it was re-scoped. A re-
scoped token is one that was exchanged for another token of the
same or different scope. You can use these audit IDs to track the
use of a token or chain of tokens across multiple requests and
endpoints without exposing the token ID to non-privileged users.
in: body
required: true
type: array
auth:
description: |
An ``auth`` object.
in: body
required: true
type: object
auth_application_credential_body:
description: |
Whether the application credential is permitted to be used for creating and
deleting additional application credentials and trusts.
in: body
required: true
type: object
auth_domain:
description: |
Specify either ``id`` or ``name`` to uniquely
identify the domain.
in: body
required: false
type: object
auth_methods:
description: |
The authentication methods, which are commonly ``password``,
``token``, or other methods. Indicates the accumulated set of
authentication methods that were used to obtain the token. For
example, if the token was obtained by password authentication, it
contains ``password``. Later, if the token is exchanged by using
the token authentication method one or more times, the
subsequently created tokens contain both ``password`` and
``token`` in their ``methods`` attribute. Unlike multi-factor
authentication, the ``methods`` attribute merely indicates the
methods that were used to authenticate the user in exchange for a
token. The client is responsible for determining the total number
of authentication factors.
in: body
required: true
type: array
auth_methods_application_credential:
description: |
The authentication method. To authenticate with an application credential,
specify ``application_credential``.
in: body
required: true
type: array
auth_methods_passwd:
description: |
The authentication method. For password
authentication, specify ``password``.
in: body
required: true
type: array
auth_methods_receipt:
description: |
The authentication methods, which are commonly ``password``,
``totp``, or other methods. Indicates the accumulated set of
authentication methods that were used to obtain the receipt. For
example, if the receipt was obtained by password authentication, it
contains ``password``. Later, if the receipt is exchanged by using
another authentication method one or more times, the
subsequently created receipts could contain both ``password`` and
``totp`` in their ``methods`` attribute.
in: body
required: true
type: array
auth_methods_token:
description: |
The authentication method. For token
authentication, specify ``token``.
in: body
required: true
type: array
auth_methods_totp:
description: |
The authentication method. For totp
authentication, specify ``totp``.
in: body
required: true
type: array
auth_token:
description: |
A ``token`` object. The token authentication
method is used. This method is typically used in combination with
a request to change authorization scope.
in: body
required: true
type: object
auth_token_id:
description: |
A token ID.
in: body
required: true
type: string
catalog:
description: |
A ``catalog`` object.
in: body
required: true
type: array
catalog_response_body_optional:
description: |
A ``catalog`` object.
in: body
required: false
type: array
credential:
description: |
A ``credential`` object.
in: body
required: true
type: object
credential_blob:
description: |
The credential itself, as a serialized blob.
in: body
required: true
type: string
credential_blob_not_required:
description: |
The credential itself, as a serialized blob.
in: body
required: false
type: string
credential_id:
description: |
The UUID for the credential.
in: body
required: true
type: string
credential_links:
description: |
The links for the ``credential`` resource.
in: body
required: true
type: object
credential_type:
description: |
The credential type, such as ``ec2`` or ``cert``.
The implementation determines the list of supported types.
in: body
required: true
type: string
credential_type_not_required:
description: |
The credential type, such as ``ec2`` or ``cert``.
The implementation determines the list of supported types.
in: body
required: false
type: string
credential_user_id:
description: |
The ID of the user who owns the credential.
in: body
required: true
type: string
credential_user_id_not_required:
description: |
The ID of the user who owns the credential.
in: body
required: false
type: string
credentials:
description: |
A list of ``credential`` objects.
in: body
required: true
type: array
credentials_links:
description: |
The links for the ``credentials`` resource.
in: body
required: true
type: object
default_limit:
description: |
The default limit for the registered limit.
in: body
required: true
type: integer
default_project_id_request_body:
description: |
The ID of the default project for the user.
A user's default project must not be a domain. Setting this
attribute does not grant any actual authorization on the project,
and is merely provided for convenience. Therefore, the referenced
project does not need to exist within the user domain. (Since v3.1)
If the user does not have authorization to their default project,
the default project is ignored at token creation. (Since v3.1)
Additionally, if your default project is not valid, a token is
issued without an explicit scope of authorization.
in: body
required: false
type: string
default_project_id_response_body:
description: |
The ID of the default project for the user.
in: body
required: false
type: string
default_project_id_update_body:
description: |
The new ID of the default project for the user.
in: body
required: false
type: string
description_limit_request_body:
description: |
The limit description.
in: body
required: false
type: string
description_limit_response_body:
description: |
The limit description.
in: body
required: true
type: string
description_region_request_body:
description: |
The region description.
in: body
required: false
type: string
description_region_response_body:
description: |
The region description.
in: body
required: true
type: string
description_registered_limit_request_body:
description: |
The registered limit description.
in: body
required: false
type: string
description_registered_limit_response_body:
description: |
The registered limit description.
in: body
required: true
type: string
domain:
description: |
A ``domain`` object
in: body
required: true
type: object
domain_config:
description: |
A ``config`` object.
in: body
required: true
type: object
domain_description_request_body:
description: |
The description of the domain.
in: body
required: false
type: string
domain_description_response_body:
description: |
The description of the domain.
in: body
required: true
type: string
domain_description_update_request_body:
description: |
The new description of the domain.
in: body
required: false
type: string
domain_driver:
description: |
The Identity backend driver.
in: body
required: true
type: string
domain_enabled_request_body:
description: |
If set to ``true``, domain is created enabled. If set to
``false``, domain is created disabled. The default is ``true``.
Users can only authorize against an enabled domain (and any of its
projects). In addition, users can only authenticate if the domain that owns
them is also enabled. Disabling a domain prevents both of these things.
in: body
required: false
type: string
domain_enabled_response_body:
description: |
If set to ``true``, domain is enabled. If set to
``false``, domain is disabled.
in: body
required: true
type: string
domain_enabled_update_request_body:
description: |
If set to ``true``, domain is enabled. If set to
``false``, domain is disabled. The default is ``true``.
Users can only authorize against an enabled domain (and any of its
projects). In addition, users can only authenticate if the domain that owns
them is also enabled. Disabling a domain prevents both of these things.
When you disable a domain, all tokens that are authorized for that domain
become invalid. However, if you reenable the domain, these tokens become
valid again, providing that they haven't expired.
in: body
required: false
type: string
domain_id_response_body:
description: |
The ID of the domain.
in: body
required: true
type: string
domain_ldap:
description: |
An ``ldap`` object. Required to set the LDAP
group configuration options.
in: body
required: true
type: object
domain_link_response_body:
description: |
The links to the ``domain`` resource.
in: body
required: true
type: object
domain_name_request_body:
description: |
The name of the domain.
in: body
required: true
type: string
domain_name_response_body:
description: |
The name of the domain.
in: body
required: true
type: string
domain_name_update_request_body:
description: |
The new name of the domain.
in: body
required: false
type: string
domain_scope_response_body_optional:
description: |
A ``domain`` object including the ``id`` and ``name`` representing the
domain the token is scoped to. This is only included in tokens that are
scoped to a domain.
in: body
required: false
type: object
domain_url:
description: |
The LDAP URL.
in: body
required: true
type: string
domain_user_tree_dn:
description: |
The base distinguished name (DN) of LDAP, from
where all users can be reached. For example,
``ou=Users,dc=root,dc=org``.
in: body
required: true
type: string
domains:
description: |
A list of ``domain`` objects
in: body
required: true
type: array
email:
description: |
The email address for the user.
in: body
required: true
type: string
enabled_user_request_body:
description: |
If the user is enabled, this value is ``true``.
If the user is disabled, this value is ``false``.
in: body
required: false
type: boolean
enabled_user_response_body:
description: |
If the user is enabled, this value is ``true``.
If the user is disabled, this value is ``false``.
in: body
required: true
type: boolean
enabled_user_update_body:
description: |
Enables or disables the user. An enabled user
can authenticate and receive authorization. A disabled user
cannot authenticate or receive authorization. Additionally, all
tokens that the user holds become no longer valid. If you reenable
this user, pre-existing tokens do not become valid. To enable the
user, set to ``true``. To disable the user, set to ``false``.
Default is ``true``.
in: body
required: false
type: boolean
endpoint:
description: |
An ``endpoint`` object.
in: body
required: true
type: object
endpoint_enabled:
description: |
Indicates whether the endpoint appears in the
service catalog: - ``false``. The endpoint does not appear in the
service catalog. - ``true``. The endpoint appears in the service
catalog.
in: body
required: true
type: boolean
endpoint_enabled_not_required:
description: |
Defines whether the endpoint appears in the
service catalog: - ``false``. The endpoint does not appear in the
service catalog. - ``true``. The endpoint appears in the service
catalog. Default is ``true``.
in: body
required: false
type: boolean
endpoint_id:
description: |
The endpoint ID.
in: body
required: true
type: string
endpoint_interface:
description: |
The interface type, which describes the
visibility of the endpoint. Value is: - ``public``. Visible by
end users on a publicly available network interface. -
``internal``. Visible by end users on an unmetered internal
network interface. - ``admin``. Visible by administrative users
on a secure network interface.
in: body
required: true
type: string
endpoint_links:
description: |
The links for the ``endpoint`` resource.
in: body
required: true
type: object
endpoint_name:
description: |
The endpoint name.
in: body
required: true
type: string
endpoint_region:
description: |
(Deprecated in v3.2) The geographic location of
the service endpoint.
in: body
required: true
type: string
endpoint_type:
description: |
The endpoint type.
in: body
required: true
type: string
endpoint_url:
description: |
The endpoint URL.
in: body
required: true
type: string
endpoints:
description: |
A list of ``endpoint`` objects.
in: body
required: true
type: array
endpoints_links:
description: |
The links for the ``endpoints`` resource.
in: body
required: true
type: object
expires_at:
description: |
The date and time when the token expires.
The date and time stamp format is `ISO 8601
<https://en.wikipedia.org/wiki/ISO_8601>`_:
::
CCYY-MM-DDThh:mm:ss.sssZ
For example, ``2015-08-27T09:49:58.000000Z``.
A ``null`` value indicates that the token never expires.
in: body
required: true
type: string
explicit_unscoped_string:
description: |
The authorization scope (Since v3.4). Specify
``unscoped`` to make an explicit unscoped token request, which
returns an unscoped response without any authorization. This
request behaves the same as a token request with no scope where
the user has no default project defined. If an explicit,
``unscoped`` token request is not made and the user has
authorization to their default project, then the response will
return a project-scoped token. If a default project is not defined,
a token is issued without an explicit scope of authorization,
which is the same as asking for an explicit unscoped token.
in: body
required: false
type: string
extra_request_body:
description: |
The extra attributes of a resource.
The actual name ``extra`` is not the key name in the request body,
but rather a collection of any attributes that a resource may contain
that are not part of the resource's default attributes.
Generally these are custom fields that are added to a resource in keystone
by operators for their own specific uses,
such as ``email`` and ``description`` for users.
in: body
required: false
type: string
federated_in_request_body:
description: |
List of federated objects associated with a user. Each object in the list
contains the ``idp_id`` and ``protocols``. ``protocols`` is a list of
objects, each of which contains ``protocol_id`` and ``unique_id`` of
the protocol and user respectively. For example::
"federated": [
{
"idp_id": "efbab5a6acad4d108fec6c63d9609d83",
"protocols": [
{"protocol_id": mapped, "unique_id": "test@example.com"}
]
}
]
in: body
required: false
type: list
federated_in_response_body:
description: |
List of federated objects associated with a user. Each object in the list
contains the ``idp_id`` and ``protocols``. ``protocols`` is a list of
objects, each of which contains ``protocol_id`` and ``unique_id`` of
the protocol and user respectively. For example::
"federated": [
{
"idp_id": "efbab5a6acad4d108fec6c63d9609d83",
"protocols": [
{"protocol_id": "mapped", "unique_id": "test@example.com"}
]
}
]
in: body
required: false
type: list
group:
description: |
A ``group`` object
in: body
required: true
type: object
group_description_request_body:
description: |
The description of the group.
in: body
required: false
type: string
group_description_response_body:
description: |
The description of the group.
in: body
required: true
type: string
group_description_update_request_body:
description: |
The new description of the group.
in: body
required: false
type: string
group_domain_id:
description: |
The ID of the domain that owns the group. If you
omit the domain ID, defaults to the domain to which the client
token is scoped.
in: body
required: false
type: string
group_domain_id_request_body:
description: |
The ID of the domain of the group. If the domain ID is not
provided in the request, the Identity service will attempt to
pull the domain ID from the token used in the request. Note that
this requires the use of a domain-scoped token.
in: body
required: false
type: string
group_domain_id_response_body:
description: |
The ID of the domain of the group.
in: body
required: true
type: string
group_domain_id_update_request_body:
description: |
The ID of the new domain for the group. The ability to change the domain
of a group is now deprecated, and will be removed in subsequent release.
It is already disabled by default in most Identity service implementations.
in: body
required: false
type: string
group_id_response_body:
description: |
The ID of the group.
in: body
required: true
type: string
group_name_request_body:
description: |
The name of the group.
in: body
required: true
type: string
group_name_response_body:
description: |
The name of the group.
in: body
required: true
type: string
group_name_update_request_body:
description: |
The new name of the group.
in: body
required: false
type: string
groups:
description: |
A list of ``group`` objects
in: body
required: true
type: array
id_region_response_body:
description: |
The ID for the region.
in: body
required: true
type: string
id_region_resquest_body:
description: |
The ID for the region.
in: body
required: false
type: string
id_user_body:
description: |
The user ID.
in: body
required: true
type: string
identity:
description: |
An ``identity`` object.
in: body
required: true
type: object
implies_role_array_body:
description: |
An array of implied role objects.
in: body
required: true
type: array
implies_role_object_body:
description: |
An implied role object.
in: body
required: true
type: object
is_domain_request_body:
description: |
Indicates whether the project also acts as a domain. If set to ``true``,
this project acts as both a project and domain. As a domain, the project
provides a name space in which you can create users, groups, and other
projects. If set to ``false``, this project behaves as a regular project
that contains only resources. Default is ``false``. You cannot update
this parameter after you create the project.
in: body
required: false
type: boolean
min_version: 3.6
is_domain_response_body:
description: |
Indicates whether the project also acts as a domain. If set to ``true``,
this project acts as both a project and domain. As a domain, the project
provides a name space in which you can create users, groups, and other
projects. If set to ``false``, this project behaves as a regular project
that contains only resources.
in: body
required: true
type: boolean
min_version: 3.6
issued_at:
description: |
The date and time when the token was issued.
The date and time stamp format is `ISO 8601
<https://en.wikipedia.org/wiki/ISO_8601>`_:
::
CCYY-MM-DDThh:mm:ss.sssZ
For example, ``2015-08-27T09:49:58.000000Z``.
in: body
required: true
type: string
limit:
description: |
A ``limit`` object
in: body
required: true
type: array
limit_id:
description: |
The limit ID.
in: body
required: true
type: string
limit_model_description_required_response_body:
description: A short description of the enforcement model used
in: body
required: true
type: string
limit_model_name_required_response_body:
description: The name of the enforcement model
in: body
required: true
type: string
limit_model_required_response_body:
description: A model object describing the configured enforcement model used
by the deployment.
in: body
required: true
type: object
limits:
description: |
A list of ``limits`` objects
in: body
required: true
type: array
link_collection:
description: |
The link to the collection of resources.
in: body
required: true
type: object
link_response_body:
description: |
The link to the resources in question.
in: body
required: true
type: object
links_project:
description: |
The links for the ``project`` resource.
in: body
required: true
type: object
links_region:
description: |
The links for the ``region`` resource.
in: body
required: true
type: object
links_user:
description: |
The links for the ``user`` resource.
in: body
required: true
type: object
membership_expires_at_response_body:
description: |
The date and time when the group membership expires.
A ``null`` value indicates that the membership never expires.
in: body
required: true
type: string
min_version: 3.14
original_password:
description: |
The original password for the user.
in: body
required: true
type: string
parent_region_id_request_body:
description: |
To make this region a child of another region,
set this parameter to the ID of the parent region.
in: body
required: false
type: string
parent_region_id_response_body:
description: |
To make this region a child of another region,
set this parameter to the ID of the parent region.
in: body
required: true
type: string
password:
description: |
The ``password`` object, contains the authentication information.
in: body
required: true
type: object
password_expires_at:
description: |
The date and time when the password expires. The time zone
is UTC.
This is a response object attribute; not valid for requests.
A ``null`` value indicates that the password never expires.
in: body
required: true
type: string
min_version: 3.7
password_request_body:
description: |
The password for the user.
in: body
required: false
type: string
policies:
description: |
A ``policies`` object.
in: body
required: true
type: array
policy:
description: |
A ``policy`` object.
in: body
required: true
type: object
policy_blob_obj:
description: |
The policy rule itself, as a serialized blob.
in: body
required: true
type: object
policy_blob_str:
description: |
The policy rule set itself, as a serialized blob.
in: body
required: true
type: string
policy_id:
description: |
The policy ID.
in: body
required: true
type: string
policy_links:
description: |
The links for the ``policy`` resource.
in: body
required: true
type: object
policy_type:
description: |
The MIME media type of the serialized policy
blob.
in: body
required: true
type: string
prior_role_body:
description: |
A prior role object.
in: body
required: true
type: object
project:
description: |
A ``project`` object
in: body
required: true
type: object
project_description_request_body:
description: |
The description of the project.
in: body
required: false
type: string
project_description_response_body:
description: |
The description of the project.
in: body
required: true
type: string
project_domain_id:
description: |
The ID of the domain for the project. If you
omit the domain ID, default is the domain to which your token is
scoped.
in: body
required: false
type: string
project_domain_id_request_body:
description: |
The ID of the domain for the project.
For projects acting as a domain, the ``domain_id`` must not be specified,
it will be generated by the Identity service implementation.
For regular projects (i.e. those not acing as a domain), if ``domain_id``
is not specified, but ``parent_id`` is specified, then the domain ID of the
parent will be used. If neither ``domain_id`` or ``parent_id`` is
specified, the Identity service implementation will default to the domain
to which the client's token is scoped. If both ``domain_id`` and
``parent_id`` are specified, and they do not indicate the same domain, an
``Bad Request (400)`` will be returned.
in: body
required: false
type: string
project_domain_id_response_body:
description: |
The ID of the domain for the project.
in: body
required: true
type: string
project_domain_id_update_request_body:
description: |
The ID of the new domain for the project. The ability to change the domain
of a project is now deprecated, and will be removed in subequent release.
It is already disabled by default in most Identity service implementations.
in: body
required: false
type: string
project_enabled_request_body:
description: |
If set to ``true``, project is enabled. If set to
``false``, project is disabled. The default is ``true``.
in: body
required: false
type: boolean
project_enabled_response_body:
description: |
If set to ``true``, project is enabled. If set to
``false``, project is disabled.
in: body
required: true
type: boolean
project_enabled_update_request_body:
description: |
If set to ``true``, project is enabled. If set to
``false``, project is disabled.
in: body
required: false
type: boolean
project_id:
description: |
The ID for the project.
in: body
required: true
type: string
project_name_request_body:
description: |
The name of the project, which must be unique within the
owning domain. A project can have the same name as its domain.
in: body
required: true
type: string
project_name_response_body:
description: |
The name of the project.
in: body
required: true
type: string
project_name_update_request_body:
description: |
The name of the project, which must be unique within the
owning domain. A project can have the same name as its domain.
in: body
required: false
type: string
project_parent_id_request_body:
description: |
The ID of the parent of the project.
If specified on project creation, this places the project within a
hierarchy and implicitly defines the owning domain, which will be the
same domain as the parent specified. If ``parent_id`` is
not specified and ``is_domain`` is ``false``, then the project will use its
owning domain as its parent. If ``is_domain`` is ``true`` (i.e. the project
is acting as a domain), then ``parent_id`` must not specified (or if it is,
it must be ``null``) since domains have no parents.
``parent_id`` is immutable, and can't be updated after the project is
created - hence a project cannot be moved within the hierarchy.
in: body
required: false
type: string
min_version: 3.4
project_parent_id_response_body:
description: |
The ID of the parent for the project.
in: body
required: true
type: string
min_version: 3.4
project_scope_response_body_optional:
description: |
A ``project`` object including the ``id``, ``name`` and ``domain`` object
representing the project the token is scoped to. This is only included in
tokens that are scoped to a project.
in: body
required: false
type: object
project_tags_request_body:
description: |
A list of simple strings assigned to a project.
Tags can be used to classify projects into groups.
in: body
required: false
type: array
projects:
description: |
A list of ``project`` objects
in: body
required: true
type: array
receipt_expires_at:
description: |
The date and time when the receipt expires.
The date and time stamp format is `ISO 8601
<https://en.wikipedia.org/wiki/ISO_8601>`_:
::
CCYY-MM-DDThh:mm:ss.sssZ
For example, ``2015-08-27T09:49:58.000000Z``.
A ``null`` value indicates that the receipt never expires.
in: body
required: true
type: string
receipt_issued_at:
description: |
The date and time when the receipt was issued.
The date and time stamp format is `ISO 8601
<https://en.wikipedia.org/wiki/ISO_8601>`_:
::
CCYY-MM-DDThh:mm:ss.sssZ
For example, ``2015-08-27T09:49:58.000000Z``.
in: body
required: true
type: string
region_id_not_required:
description: |
(Since v3.2) The ID of the region that contains
the service endpoint.
in: body
required: false
type: string
region_id_request_body:
description: |
The ID of the region that contains the service endpoint.
in: body
required: false
type: string
region_id_required:
description: |
(Since v3.2) The ID of the region that contains
the service endpoint.
in: body
required: true
type: string
region_id_response_body:
description: |
The ID of the region that contains the service endpoint.
The value can be None.
in: body
required: true
type: string
region_object:
description: |
A ``region`` object
in: body
required: true
type: object
regions_object:
description: |
A list of ``region`` object
in: body
required: true
type: array
registered_limit:
description: |
A ``registered_limit`` objects
in: body
required: true
type: array
registered_limit_id:
description: |
The registered limit ID.
in: body
required: true
type: string
registered_limits:
description: |
A list of ``registered_limits`` objects
in: body
required: true
type: array
request_application_credential_access_rules_body_not_required:
description: |
A list of ``access_rules`` objects
in: body
required: false
type: list
request_application_credential_auth_id_body_not_required:
description: |
The ID of the application credential used for authentication. If not
provided, the application credential must be identified by its name and
its owning user.
in: body
required: false
type: string
request_application_credential_auth_name_body_not_required:
description: |
The name of the application credential used for authentication. If
provided, must be accompanied by a user object.
in: body
required: false
type: string
request_application_credential_auth_secret_body_required:
description: |
The secret for authenticating the application credential.
in: body
required: true
type: string
request_application_credential_body_required:
description: |
An application credential object.
in: body
required: true
type: object
request_application_credential_description_body_not_required:
description: |
A description of the application credential's purpose.
in: body
required: false
type: string
request_application_credential_expires_at_body_not_required:
description: |
An optional expiry time for the application credential. If unset, the
application credential does not expire.
in: body
required: false
type: string
request_application_credential_name_body_required:
description: |
The name of the application credential. Must be unique to a user.
in: body
required: true
type: string
request_application_credential_roles_body_not_required:
description: |
An optional list of role objects, identified by ID or name. The list
may only contain roles that the user has assigned on the project.
If not provided, the roles assigned to the application credential will
be the same as the roles in the current token.
in: body
required: false
type: array
request_application_credential_secret_body_not_required:
description: |
The secret that the application credential will be created with. If not
provided, one will be generated.
in: body
required: false
type: string
request_application_credential_unrestricted_body_not_required:
description: |
An optional flag to restrict whether the application credential may be
used for the creation or destruction of other application credentials or
trusts. Defaults to false.
in: body
required: false
type: boolean
request_application_credential_user_body_not_required:
description: |
A ``user`` object, required if an application credential is identified by
name and not ID.
in: body
required: false
type: object
request_default_limit_body_not_required:
description: |
The default limit for the registered limit.
in: body
required: false
type: integer
request_domain_options_body_not_required:
description: |
The resource options for the domain. Available resource options are
``immutable``.
in: body
required: false
type: object
request_explicit_domain_id_body_not_required:
description: |
The ID of the domain. A domain created this way will not use an
auto-generated ID, but will use the ID passed in instead. Identifiers passed
in this way must conform to the existing ID generation scheme: UUID4 without
dashes.
in: body
required: false
type: string
request_limit_domain_id_not_required:
description: |
The name of the domain.
in: body
required: false
type: string
request_limit_project_id_not_required:
description: |
The ID for the project.
in: body
required: false
type: string
request_project_options_body_not_required:
description: |
The resource options for the project. Available resource options are
``immutable``.
in: body
required: false
type: object
request_region_id_registered_limit_body_not_required:
description: |
The ID of the region that contains the service endpoint.
Either service_id, resource_name, or region_id must be
different than existing value otherwise it will raise 409.
in: body
required: false
type: string
request_resource_limit_body_not_required:
description: |
The override limit.
in: body
required: false
type: integer
request_resource_name_body_not_required:
description: |
The resource name. Either service_id, resource_name or
region_id must be different than existing value otherwise
it will raise 409.
in: body
required: false
type: string
request_role_options_body_not_required:
description: |
The resource options for the role. Available resource options are
``immutable``.
in: body
required: false
type: object
request_service_id_registered_limit_body_not_required:
description: |
The UUID of the service to update to which the registered
limit belongs. Either service_id, resource_name, or region_id
must be different than existing value otherwise it will
raise 409.
in: body
required: false
type: string
required_auth_methods:
description: |
A list of authentication rules that may be used with the auth receipt
to complete the authentication process.
in: body
required: true
type: list of lists
resource_limit:
description: |
The override limit.
in: body
required: true
type: integer
resource_name:
description: |
The resource name.
in: body
required: true
type: string
response_access_rules_body:
description: |
A list of ``access_rules`` objects
in: body
type: list
required: true
response_access_rules_id_body:
description: |
The ID of the access rule
in: body
type: string
required: true
response_access_rules_method_body:
description: |
The request method that the application credential is permitted to use for
a given API endpoint.
in: body
type: string
required: true
response_access_rules_path_body:
description: |
The API path that the application credential is permitted to access. May
use named wildcards such as ``{tag}`` or the unnamed wildcard ``*`` to
match against any string in the path up to a ``/``, or the recursive
wildcard ``**`` to include ``/`` in the matched path.
in: body
type: string
required: true
response_access_rules_service_body:
description: |
The service type identifier for the service that the application credential
is permitted to access. Must be a service type that is listed in the
service catalog and not a code name for a service.
in: body
type: string
required: true
response_application_credential_access_rules_body:
description: |
A list of ``access_rules`` objects
in: body
type: list
required: true
response_application_credential_body:
description: |
The application credential object.
in: body
type: object
required: true
response_application_credential_description_body:
description: |
A description of the application credential's purpose.
in: body
type: string
required: true
response_application_credential_expires_at_body:
description: |
The expiration time of the application credential, if one was specified.
in: body
type: string
required: true
response_application_credential_id_body:
description: |
The ID of the application credential.
in: body
type: string
required: true
response_application_credential_name_body:
description: |
The name of the application credential.
in: body
type: string
required: true
response_application_credential_project_id_body:
description: |
The ID of the project the application credential was created for and that
authentication requests using this application credential will be scoped
to.
in: body
type: string
required: true
response_application_credential_roles_body:
description: |
A list of one or more roles that this application credential has
associated with its project. A token using this application credential
will have these same roles.
in: body
type: array
required: true
response_application_credential_secret_body:
description: |
The secret for the application credential, either generated by the server
or provided by the user. This is only ever shown once in the response to a
create request. It is not stored nor ever shown again. If the secret is
lost, a new application credential must be created.
in: body
type: string
required: true
response_application_credential_unrestricted_body:
description: |
A flag indicating whether the application credential may be used for
creation or destruction of other application credentials or trusts.
in: body
type: boolean
required: true
response_body_project_tags_required:
description: |
A list of simple strings assigned to a project.
in: body
required: true
type: array
response_body_system_required:
description: |
A list of systems to access based on role assignments.
in: body
required: true
type: array
response_domain_options_body_required:
description: |
The resource options for the domain. Available resource options are
``immutable``.
in: body
required: true
type: object
response_limit_domain_id_body:
description: |
The ID of the domain.
in: body
required: true
type: string
response_project_options_body_required:
description: |
The resource options for the project. Available resource options are
``immutable``.
in: body
required: true
type: object
response_role_options_body_required:
description: |
The resource options for the role. Available resource options are
``immutable``.
in: body
required: true
type: object
response_user_options_body_required:
description: |
The resource options for the user. Available resource options are
``ignore_change_password_upon_first_use``, ``ignore_password_expiry``,
``ignore_lockout_failure_attempts``, ``lock_password``,
``multi_factor_auth_enabled``, and ``multi_factor_auth_rules``
``ignore_user_inactivity``.
in: body
required: true
type: object
role:
description: |
A ``role`` object
in: body
required: true
type: object
role_assignments:
description: |
A list of ``role_assignment`` objects.
in: body
required: true
type: array
role_description_create_body:
description: |
Add description about the role.
in: body
required: false
type: string
role_description_response_body_required:
description: |
The role description.
in: body
required: true
type: string
role_description_update_body:
description: |
The new role description.
in: body
required: false
type: string
role_domain_id_request_body:
description: |
The ID of the domain of the role.
in: body
required: false
type: string
role_id_response_body:
description: |
The role ID.
in: body
required: true
type: string
role_inference_array_body:
description: |
An array of ``role_inference`` object.
in: body
required: true
type: array
role_inference_body:
description: |
Role inference object that contains ``prior_role`` object
and ``implies`` object.
in: body
required: true
type: object
role_name_create_body:
description: |
The role name.
in: body
required: true
type: string
role_name_response_body:
description: |
The role name.
in: body
required: true
type: string
role_name_update_body:
description: |
The new role name.
in: body
required: false
type: string
roles:
description: |
A list of ``role`` objects
in: body
required: true
type: array
scope_string:
description: |
The authorization scope, including the system (Since v3.10), a project, or
a domain (Since v3.4). If multiple scopes are specified in the same request
(e.g. ``project`` and ``domain`` or ``domain`` and ``system``) an HTTP
``400 Bad Request`` will be returned, as a token cannot be simultaneously
scoped to multiple authorization targets. An ID is sufficient to uniquely
identify a project but if a project is specified by name, then the domain
of the project must also be specified in order to uniquely identify the
project by name. A domain scope may be specified by either the domain's ID
or name with equivalent results.
in: body
required: false
type: string
service:
description: |
A ``service`` object.
in: body
required: true
type: object
service_description:
description: |
The service description.
in: body
required: false
type: string
service_description_not_required:
description: |
The service description.
in: body
required: false
type: string
service_enabled:
description: |
Defines whether the service and its endpoints
appear in the service catalog: - ``false``. The service and its
endpoints do not appear in the service catalog. - ``true``. The
service and its endpoints appear in the service catalog.
in: body
required: false
type: boolean
service_enabled_not_required:
description: |
Defines whether the service and its endpoints
appear in the service catalog: - ``false``. The service and its
endpoints do not appear in the service catalog. - ``true``. The
service and its endpoints appear in the service catalog.
Default is ``true``.
in: body
required: false
type: boolean
service_id:
description: |
The UUID of the service to which the endpoint
belongs.
in: body
required: true
type: string
service_id_limit:
description: |
The UUID of the service to which the limit belongs.
in: body
required: true
type: string
service_id_registered_limit:
description: |
The UUID of the service to which the registered limit
belongs.
in: body
required: true
type: string
service_links:
description: |
The links for the ``service`` resource.
in: body
required: true
type: object
service_name:
description: |
The service name.
in: body
required: true
type: string
service_type:
description: |
The service type, which describes the API
implemented by the service. Value is ``compute``, ``ec2``,
``identity``, ``image``, ``network``, or ``volume``.
in: body
required: true
type: string
services:
description: |
A list of ``service`` object.
in: body
required: true
type: array
system:
description: |
A ``system`` object.
in: body
required: false
type: object
system_roles_response_body:
description: |
A list of ``role`` objects containing ``domain_id``, ``id``, ``links``,
and ``name`` attributes.
in: body
required: true
type: array
system_scope_response_body_optional:
description: |
A ``system`` object containing information about which parts of the system
the token is scoped to. If the token is scoped to the entire deployment
system, the ``system`` object will consist of ``{"all": true}``. This is
only included in tokens that are scoped to the system.
in: body
required: false
type: object
system_scope_string:
description: |
Authorization scope specific to the deployment system (Since v3.10).
Specifying a project or domain scope in addition to system scope results
in an HTTP ``400 Bad Request``.
in: body
required: false
type: string
token:
description: |
A ``token`` object.
in: body
required: true
type: object
totp:
description: |
The ``totp`` object, contains the authentication information.
in: body
required: true
type: object
user:
description: |
A ``user`` object.
in: body
required: true
type: object
user_domain_id:
description: |
The ID of the domain for the user.
in: body
required: false
type: string
user_domain_id_request_body:
description: |
The ID of the domain of the user. If the domain ID is not
provided in the request, the Identity service will attempt to
pull the domain ID from the token used in the request. Note that
this requires the use of a domain-scoped token.
in: body
required: false
type: string
user_domain_id_update_body:
description: |
The ID of the new domain for the user. The ability to change the domain
of a user is now deprecated, and will be removed in subequent release.
It is already disabled by default in most Identity service implementations.
in: body
required: false
type: string
user_id:
description: |
The ID of the user. Required if you do not
specify the user name.
in: body
required: false
type: string
user_name:
description: |
The user name. Required if you do not specify
the ID of the user. If you specify the user name, you must also
specify the domain, by ID or name.
in: body
required: false
type: string
user_name_create_request_body:
description: |
The user name. Must be unique within the owning domain.
in: body
required: true
type: string
user_name_response_body:
description: |
The user name. Must be unique within the owning domain.
in: body
required: true
type: string
user_name_update_body:
description: |
The new name for the user. Must be unique within the owning domain.
in: body
required: false
type: string
user_object:
description: |
A ``user`` object
in: body
required: true
type: object
user_options_request_body:
description: |
The resource options for the user. Available resource options are
``ignore_change_password_upon_first_use``, ``ignore_password_expiry``,
``ignore_lockout_failure_attempts``, ``lock_password``,
``multi_factor_auth_enabled``, and ``multi_factor_auth_rules``
``ignore_user_inactivity``.
in: body
required: false
type: object
user_password_update_body:
description: |
The new password for the user.
in: body
required: true
type: string
user_update_password_body:
description: |
The new password for the user.
in: body
required: false
type: string
users:
description: |
A ``users`` object.
in: body
required: true
type: array
users_object:
description: |
A list of ``user`` objects
in: body
required: true
type: array
|